#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#-----------------------------------------------------------------------------
Name		:	libvirt
Version		:	9.8.0
Release		:	17.2.0.rel%{?dist}
Summary		:	Library providing a simple virtualization API

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv2+
URL		:	https://libvirt.org/
			#https://libvirt.org/sources/

Source0		:	%{name}-%{version}.tar.xz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	attr
BuildRequires	:	augeas
BuildRequires	:	audit
BuildRequires	:	bash-completion
BuildRequires	:	curl
BuildRequires	:	dbus-glib-devel
BuildRequires	:	dmidecode
BuildRequires	:	gcc
BuildRequires	:	glib-devel
BuildRequires	:	gnutls
BuildRequires	:	iptables
BuildRequires	:	libblockdev
BuildRequires	:	libcap-ng-devel
BuildRequires	:	libnl-devel
BuildRequires	:	libpcap-devel
BuildRequires	:	libssh2-devel
BuildRequires	:	libtirpc
BuildRequires	:	meson
BuildRequires	:	mdadm
BuildRequires	:	ninja
BuildRequires	:	numactl-devel
BuildRequires	:	nss
BuildRequires	:	parted
BuildRequires	:	perl
BuildRequires	:	polkit-devel
BuildRequires	:	pm-utils
BuildRequires	:	python3
BuildRequires	:	python3-sphinx
BuildRequires	:	rpcsvc-proto
BuildRequires	:	readline
BuildRequires	:	xorg-libpciaccess
BuildRequires	:	yajl-devel

Requires	:	dnsmasq
#-----------------------------------------------------------------------------
%description
Libvirt is a C toolkit to interact with the virtualization capabilities
of recent versions of Linux (and other OSes). The main package includes
the libvirtd server exporting the virtualization support.

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%{_datadir}/augeas/lenses/%{name}d.aug
%{_datadir}/augeas/lenses/virtlogd.aug
%{_datadir}/augeas/lenses/tests/test_virtlogd.aug
%{_datadir}/augeas/lenses/virtlockd.aug
%{_datadir}/augeas/lenses/tests/test_virtlockd.aug
%{_datadir}/augeas/lenses/virtproxyd.aug
%{_datadir}/augeas/lenses/tests/test_virtproxyd.aug
%{_datadir}/augeas/lenses/tests/test_virtchd.aug
%{_datadir}/augeas/lenses/libvirt_lockd.aug
%{_datadir}/augeas/lenses/virtchd.aug

#=============================================================================
%package		client
Summary		:	Client side utilities of the libvirt library

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		client
The client binaries needed to access the virtualization
capabilities of recent versions of Linux (and other OSes).

#-----------------------------------------------------------------------------
%files			client
%defattr(-,root,root,-)
%{_bindir}/virsh
%{_bindir}/virt-xml-validate
%{_bindir}/virt-pki-validate
%{_bindir}/virt-pki-query-dn
%config(noreplace) %{_sysconfdir}/%{name}/libvirt.conf
%config(noreplace) %{_sysconfdir}/%{name}/libvirt-admin.conf
%config(noreplace) %{_sysconfdir}/%{name}/virt-login-shell.conf
%attr(4750,root,virtlogin) %{_bindir}/virt-login-shell
%{_libexecdir}/virt-login-shell-helper
%{_datadir}/bash-completion/completions/virsh
%{_mandir}/man1/virsh.1.gz
%{_mandir}/man1/virt-xml-validate.1.gz
%{_mandir}/man1/virt-pki-validate.1.gz
%{_mandir}/man1/virt-qemu-qmp-proxy.1.gz
%{_mandir}/man1/virt-qemu-sev-validate.1.gz

#-----------------------------------------------------------------------------
%pre			client
getent group virtlogin >/dev/null || groupadd -r virtlogin
exit 0

#=============================================================================
%package		daemon
Summary		:	Server side daemon and supporting files for libvirt library

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	= %{version}-%{release}
Requires	:	dnsmasq
Requires	:	shadow
#-----------------------------------------------------------------------------
%description		daemon
Server side daemon required to manage the virtualization capabilities
of recent versions of Linux. Requires a hypervisor specific sub-RPM
for specific drivers.

#-----------------------------------------------------------------------------
%files			daemon
%defattr(-,root,root,-)
%{_sysconfdir}/%{name}/qemu/networks/default.xml
%{_sysconfdir}/%{name}/qemu/networks/autostart/default.xml
%dir	%{_var}/log/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/libvirtd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtproxyd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtlogd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtlockd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtchd.conf
%config(noreplace) %{_sysconfdir}/sasl2/%{name}.conf
%config(noreplace) %{_prefix}/lib/sysctl.d/60-%{name}d.conf
%config(noreplace) %{_prefix}/lib/sysctl.d/60-qemu-postcopy-migration.conf
%config(noreplace) %{_sysconfdir}/%{name}/qemu.conf
%config(noreplace) %{_sysconfdir}/%{name}/qemu-lockd.conf
%config(noreplace) %{_sysconfdir}/%{name}/lxc.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtinterfaced.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtlxcd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtnetworkd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtnodedevd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtnwfilterd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtqemud.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtsecretd.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtstoraged.conf
%config(noreplace) %{_sysconfdir}/%{name}/virtvboxd.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}d.libxl
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}d.lxc
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}d.qemu
%{_sysconfdir}/rc.d/init.d/%{name}d
%{_sysconfdir}/rc.d/init.d/virtlogd
%{_sysconfdir}/%{name}/nwfilter/*.xml
%{_bindir}/virt-qemu-run
%{_bindir}/virt-qemu-qmp-proxy
%{_bindir}/virt-qemu-sev-validate
%{_bindir}/virt-host-validate
%{_bindir}/virt-admin
%attr(0750,root,root) %{_sbindir}/%{name}d
%attr(0755,root,root) %{_bindir}/virt-ssh-helper
%attr(0755,root,root) %{_sbindir}/virtchd
%attr(0755,root,root) %{_sbindir}/virtinterfaced
%attr(0755,root,root) %{_sbindir}/virtnetworkd
%attr(0755,root,root) %{_sbindir}/virtnodedevd
%attr(0755,root,root) %{_sbindir}/virtlogd
%attr(0755,root,root) %{_sbindir}/virtlockd
%attr(0755,root,root) %{_sbindir}/virtlxcd
%attr(0755,root,root) %{_sbindir}/virtproxyd
%attr(0755,root,root) %{_sbindir}/virtqemud
%attr(0755,root,root) %{_sbindir}/virtstoraged
%attr(0755,root,root) %{_sbindir}/virtvboxd
%attr(0755,root,root) %{_sbindir}/virtnwfilterd
%attr(0755,root,root) %{_sbindir}/virtsecretd
%{_prefix}/lib/firewalld/zones/%{name}*.xml
%{_prefix}/lib/firewalld/policies/%{name}-*.xml
%{_libdir}/%{name}/connection-driver/%{name}_driver_*.so
%{_libdir}/%{name}/storage-backend/%{name}_storage_backend_*.so
%{_libdir}/%{name}/storage-file/%{name}_storage_file_fs.so
%attr(0755,root,root) %{_libdir}/%{name}/lock-driver/lockd.so
%attr(0755,root,root) %{_libexecdir}/%{name}-guests.sh
%attr(0755,root,root) %{_libexecdir}/%{name}_iohelper
%attr(0755,root,root) %{_libexecdir}/%{name}_leaseshelper
%attr(0755,root,root) %{_libexecdir}/%{name}_lxc
%attr(0755,root,root) %{_libexecdir}/%{name}_parthelper
%{_datadir}/augeas/lenses/%{name}d_lxc.aug
%{_datadir}/augeas/lenses/%{name}d_qemu.aug
%{_datadir}/augeas/lenses/tests/test_%{name}_lockd.aug
%{_datadir}/augeas/lenses/tests/test_%{name}d_lxc.aug
%{_datadir}/augeas/lenses/tests/test_%{name}d_qemu.aug
%{_datadir}/augeas/lenses/tests/test_%{name}d.aug
%{_datadir}/augeas/lenses/virtinterfaced.aug
%{_datadir}/augeas/lenses/tests/test_virtinterfaced.aug
%{_datadir}/augeas/lenses/virtnetworkd.aug
%{_datadir}/augeas/lenses/tests/test_virtnetworkd.aug
%{_datadir}/augeas/lenses/virtnodedevd.aug
%{_datadir}/augeas/lenses/tests/test_virtnodedevd.aug
%{_datadir}/augeas/lenses/virtnwfilterd.aug
%{_datadir}/augeas/lenses/tests/test_virtnwfilterd.aug
%{_datadir}/augeas/lenses/virtsecretd.aug
%{_datadir}/augeas/lenses/tests/test_virtsecretd.aug
%{_datadir}/augeas/lenses/virtstoraged.aug
%{_datadir}/augeas/lenses/tests/test_virtstoraged.aug
%{_datadir}/augeas/lenses/virtqemud.aug
%{_datadir}/augeas/lenses/tests/test_virtqemud.aug
%{_datadir}/augeas/lenses/virtlxcd.aug
%{_datadir}/augeas/lenses/tests/test_virtlxcd.aug
%{_datadir}/augeas/lenses/virtvboxd.aug
%{_datadir}/augeas/lenses/tests/test_virtvboxd.aug
%{_datadir}/bash-completion/completions/virt-admin
%{_datadir}/polkit-1/actions/org.libvirt.unix.policy
%{_datadir}/polkit-1/actions/org.libvirt.api.policy
%{_datadir}/polkit-1/rules.d/50-libvirt.rules
%{_mandir}/man1/virt-admin.1.gz
%{_mandir}/man1/virt-pki-query-dn.1.gz
%{_mandir}/man1/virt-qemu-run.1.gz
%{_mandir}/man1/virt-host-validate.1.gz
%{_mandir}/man1/virt-login-shell.1.gz
%{_mandir}/man7/virkey*.7.gz
%{_mandir}/man8/%{name}d.8.gz
%{_mandir}/man8/%{name}-guests.8.gz
%{_mandir}/man8/virtinterfaced.8.gz
%{_mandir}/man8/virtlogd.8.gz
%{_mandir}/man8/virtlockd.8.gz
%{_mandir}/man8/virtlxcd.8.gz
%{_mandir}/man8/virtproxyd.8.gz
%{_mandir}/man8/virtnetworkd.8.gz
%{_mandir}/man8/virtnodedevd.8.gz
%{_mandir}/man8/virtstoraged.8.gz
%{_mandir}/man8/virtnwfilterd.8.gz
%{_mandir}/man8/virtqemud.8.gz
%{_mandir}/man8/virtsecretd.8.gz
%{_mandir}/man8/virtvboxd.8.gz
%{_mandir}/man8/virt-ssh-helper.8.gz

#-----------------------------------------------------------------------------
%pre			daemon
if ! getent group %{name} > /dev/null ; then
  /usr/sbin/groupadd				\
	  -K GID_MIN=50				\
	  -K GID_MAX=99				\
	  %{name}
  fi

if ! getent group kvm > /dev/null ; then
  /usr/sbin/groupadd				\
	  -K GID_MIN=50				\
	  -K GID_MAX=99				\
	  kvm 
  fi

if ! getent passwd kvm > /dev/null ; then
    /usr/sbin/useradd 				\
	-r 					\
	-c "Libvirt daemon user"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g kvm					\
	-s /sbin/nologin			\
	-d /dev/null				\
	kvm	
  fi

%post			daemon
%{_sbindir}/chkconfig --add virtlogd
%{_sysconfdir}/rc.d/init.d/virtlogd condrestart > /dev/null 2>&1 || :
%{_sbindir}/chkconfig --add %{name}d
%{_sysconfdir}/rc.d/init.d/%{name}d condrestart > /dev/null 2>&1 || :

%preun			daemon
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name}d stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{name}d
  %{_sysconfdir}/rc.d/init.d/virtlogd stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del virtlogd 
  /usr/sbin/userdel kvm 
  /usr/sbin/groupdel %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#=============================================================================
%package		devel
Summary		:	Libraries, includes, etc. to compile with the libvirt library

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
Include header files & development libraries for the libvirt C library.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/%{name}.h
%{_includedir}/%{name}/%{name}-*.h
%{_includedir}/%{name}/virterror.h
%{_libdir}/%{name}.so
%{_libdir}/%{name}-admin.so
%{_libdir}/%{name}-qemu.so
%{_libdir}/%{name}-lxc.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/pkgconfig/%{name}-admin.pc
%{_libdir}/pkgconfig/%{name}-lxc.pc
%{_libdir}/pkgconfig/%{name}-qemu.pc
%{_datadir}/%{name}/api/%{name}-qemu-api.xml
%{_datadir}/libvirt/api/%{name}-api.xml
%{_datadir}/libvirt/api/%{name}-admin-api.xml
%{_datadir}/libvirt/api/%{name}-lxc-api.xml

#=============================================================================
%package		docs
Summary		:	API reference and website documentation

#-----------------------------------------------------------------------------
%description		docs
Includes the API reference for the libvirt C library, and a complete
copy of the libvirt.org website documentation.

#-----------------------------------------------------------------------------
%files			docs
%defattr(-,root,root,-)
%doc AUTHORS.rst NEWS.rst README.rst
%{_defaultdocdir}/%{name}-%{version}/examples/c/admin/*.c
%{_defaultdocdir}/%{name}-%{version}/examples/c/domain/*.c
%{_defaultdocdir}/%{name}-%{version}/examples/c/misc/*.c
%{_defaultdocdir}/%{name}-%{version}/examples/polkit/%{name}-acl.rules
%{_defaultdocdir}/%{name}-%{version}/examples/sh/virt-lxc-convert
%{_defaultdocdir}/%{name}-%{version}/examples/systemtap/*.stp
%{_defaultdocdir}/%{name}-%{version}/examples/xml/storage/*.xml
%{_defaultdocdir}/%{name}-%{version}/examples/xml/test/*.xml
%{_defaultdocdir}/%{name}-%{version}/html/*.html
%{_defaultdocdir}/%{name}-%{version}/html/logos/index.html
%{_defaultdocdir}/%{name}-%{version}/html/*.png
%{_defaultdocdir}/%{name}-%{version}/html/*.xml
%{_defaultdocdir}/%{name}-%{version}/html/css/*.css
%{_defaultdocdir}/%{name}-%{version}/html/favicon.ico
%{_defaultdocdir}/%{name}-%{version}/html/manifest.json
%{_defaultdocdir}/%{name}-%{version}/html/fonts/*.woff
%{_defaultdocdir}/%{name}-%{version}/html/fonts/LICENSE.rst
%{_defaultdocdir}/%{name}-%{version}/html/go/*.html
%{_defaultdocdir}/%{name}-%{version}/html/html/*.html
%{_defaultdocdir}/%{name}-%{version}/html/images/*.png
%{_defaultdocdir}/%{name}-%{version}/html/js/*.js
%{_defaultdocdir}/%{name}-%{version}/html/kbase/*.html
%{_defaultdocdir}/%{name}-%{version}/html/kbase/internals/*.html
%{_defaultdocdir}/%{name}-%{version}/html/logos/*.png
%{_defaultdocdir}/%{name}-%{version}/html/logos/*.svg
%{_defaultdocdir}/%{name}-%{version}/html/manpages/*.html

#=============================================================================
%package		libs
Summary		:	Client side libraries

#-----------------------------------------------------------------------------
%description		libs
Shared libraries for accessing the libvirt daemon.

#-----------------------------------------------------------------------------
%files			libs	 -f %{name}.lang
%defattr(-,root,root,-)
%license COPYING COPYING.LESSER
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}d
%{_libdir}/%{name}.so.*
%{_libdir}/%{name}-qemu.so.*
%{_libdir}/%{name}-lxc.so.*
%{_libdir}/%{name}-admin.so.*
%{_libdir}/libnss_%{name}.so.2
%{_libdir}/libnss_%{name}_guest.so.2
%{_datadir}/%{name}/cpu_map/*.xml
%{_datadir}/%{name}/schemas/*.rng
%{_datadir}/%{name}/test-screenshot.png

#=============================================================================
%prep
%setup -q
tar xf %{SOURCE1}

#-----------------------------------------------------------------------------
#building application
%build

export PYTHON=/usr/bin/python3
meson	setup						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	-D polkit=enabled				\
	-D driver_qemu=enabled				\
	-D docs=enabled					\
	-D init_script=none				\
	-D qemu_user=kvm				\
        -D qemu_group=kvm				\
	.						\
	build

meson							\
	compile						\
	-C build

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check
meson							\
	test						\
	-C build					\


#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}


DESTDIR=%{buildroot}					\
meson							\
	install						\
	-C build					\

%{__mv}							\
	%{buildroot}%{_defaultdocdir}/%{name}		\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}

%{__mkdir_p}						\
	%{buildroot}%{_var}/log/%{name}

%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

%{__cp} -a						\
	%{name}-ok_addon/virtlogd.init			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/virtlogd

%{__cp} -a						\
	%{name}-ok_addon/%{name}d.init			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/%{name}d

%find_lang %{name}
#-----------------------------------------------------------------------------
%changelog
